<template>
  <page
    class="flex-grow-1"
    id="card-data-page"
    v-if="card"
    :title="`Cartão ${card.code}`"
  >
    <v-divider />
    <v-subheader>Histórico</v-subheader>
    <v-timeline
      class="mb-5"
      dense="dense"
    >
      <v-timeline-item
        v-for="event in events"
        :key="event.id"
        :color="typeInfo(event).color"
      >
        <v-list-item
          justify="space-between"
          :to="typeInfo(event).to"
        >
          <v-list-item-content>
            <v-list-item-title>{{typeInfo(event).msg}}</v-list-item-title>
          </v-list-item-content>
          <v-col class="text-right">{{timeFromISO(event.created)}}</v-col>
        </v-list-item>
      </v-timeline-item>
    </v-timeline>
  </page>
</template>

<script lang="ts">
import Vue from 'vue'

import Page from '@/components/Page.vue'
import { DateTime } from 'luxon'

import cardInfoQuery from '@/gql/CardInfo.gql'
import cardInfoSubscription from '@/gql/CardInfoSubscription.gql'

export default Vue.extend({
  name: 'CardsPage',
  components: { Page },
  data: (): {
    card: any
  } => ({
    card: null
  }),
  computed: {
    id (): string {
      return this.$route.params.id
    },
    events (): any {
      const reversed = this.card.events.slice()
      reversed.reverse()
      return reversed
    }
  },
  apollo: {
    card: {
      query: cardInfoQuery,
      variables (): { id: string } {
        return {
          id: this.id
        }
      },
      skip (): boolean {
        return !this.id
      },
      subscribeToMore: {
        document: cardInfoSubscription,
        variables (): { id: string } {
          return {
            id: this.id
          }
        },
        skip (): boolean {
          return !this.id
        }
      }
    }
  },
  methods: {
    typeInfo (event: any) {
      switch (event.type) {
        case 'CREATED':
          return { msg: 'Cartão registrado', color: 'success' }
        case 'ASSOCIATED':
          return {
            msg: `'${event.entity && event.entity.fullname}' associado`
          }
        case 'CARD_READ':
          return {
            msg: `Cartão lido na estação ${event.entity && event.entity.node}`,
            to: { name: 'station', params: { id: event.entity.id } }
          }
      }
    },
    timeFromISO (time: string) {
      return DateTime.fromISO(time).toFormat('dd/MM/yyyy - TT')
    }
  }
})
</script>
